regina::NPDF Class Reference
Basic Packet Types

A packet that can hold a PDF document. More...

`#include <packet/npdf.h>`

Inheritance diagram for regina::NPDF:

## Public Types

enum | OwnershipPolicy { OWN_MALLOC, OWN_NEW, DEEP_COPY }
| Describes how a PDF packet should claim ownership of a block of binary data. More...
Public Types inherited from regina::NPacket
typedef ChangeEventSpan | ChangeEventBlock
| A deprecated typedef for ChangeEventSpan. More...

## Public Member Functions

| NPDF ()
| Creates a PDF packet with no document stored. More...
| NPDF (char *data, size_t size, OwnershipPolicy alloc)
| Creates a packet to store the given PDF data. More...
| ~NPDF ()
| Destroys this PDF packet and deallocates data if required. More...
const char * | data () const
| Returns a pointer to the block of raw data that forms this PDF document. More...
size_t | size () const
| Returns the size of this PDF document in bytes. More...
void | reset ()
| Empties this PDF packet so that no document is stored. More...
void | reset (char *data, size_t size, OwnershipPolicy alloc)
| Refills this PDF packet with the given PDF data. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
Public Member Functions inherited from regina::NPacket
| NPacket (NPacket *parent=0)
| Constructor that inserts the new packet into the overall tree structure. More...
virtual | ~NPacket ()
| Destructor that also orphans this packet and destroys all of its descendants. More...
virtual PacketType | getPacketType () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | getPacketTypeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | getPacketLabel () const
| Returns the label associated with this individual packet. More...
std::string | getHumanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
void | setPacketLabel (const std::string &newLabel)
| Sets the label associated with this individual packet. More...
std::string | getFullName () const
| Returns a descriptive text string for the packet. More...
std::string | makeUniqueLabel (const std::string &base) const
| Returns a new label that cannot be found anywhere in the entire tree structure. More...
bool | makeUniqueLabels (NPacket *reference)
| Ensures that all packet labels in both this and the given packet tree combined are distinct. More...
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | getTags () const
| Returns the set of all tags associated with this packet. More...
bool | listen (NPacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (NPacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (NPacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
NPacket * | getTreeParent () const
| Determines the parent packet in the tree structure. More...
NPacket * | getFirstTreeChild () const
| Determines the first child of this packet in the tree structure. More...
NPacket * | getLastTreeChild () const
| Determines the last child of this packet in the tree structure. More...
NPacket * | getNextTreeSibling () const
| Determines the next sibling of this packet in the tree structure. More...
NPacket * | getPrevTreeSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
NPacket * | getTreeMatriarch () const
| Determines the matriarch (the root) of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const NPacket *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const NPacket *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const NPacket *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
unsigned long | getNumberOfChildren () const
| Returns the number of immediate children of this packet. More...
unsigned long | getNumberOfDescendants () const
| Returns the total number of descendants of this packet. More...
unsigned long | getTotalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
void | insertChildFirst (NPacket *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (NPacket *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (NPacket *newChild, NPacket *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (NPacket *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
NPacket * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const NPacket * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
NPacket * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const NPacket * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
NPacket * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const NPacket * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
NPacket * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const NPacket * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
NPacket * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
void | writeXMLFile (std::ostream &out) const
| Writes a complete XML file containing the subtree with this packet as matriarch. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
Static Public Member Functions inherited from regina::NPacket
static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
| Returns a newly created XML element reader that will read the contents of a single XML packet element. More...

## Protected Member Functions

virtual NPacket * | internalClonePacket (NPacket *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
Protected Member Functions inherited from regina::NPacket
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...
Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

A packet that can hold a PDF document.

This packet may or may not contain a PDF document at any given time. This state can be changed by calling reset().

## Member Enumeration Documentation

enum regina::NPDF::OwnershipPolicy

Describes how a PDF packet should claim ownership of a block of binary data.

Python:
  Not present.

Enumerator
OWN_MALLOC | The packet should claim ownership of the block, and should assume that it was allocated using malloc().
OWN_NEW | The packet should claim ownership of the block, and should assume that it was allocated using `new`[].
DEEP_COPY | The packet should not claim ownership of the block, but should instead make its own deep copy.

## Constructor & Destructor Documentation

regina::NPDF::NPDF | ( |  | ) |

inline

Creates a PDF packet with no document stored.

regina::NPDF::NPDF | ( | char * | data,
|  | size_t | size,
|  | OwnershipPolicy | alloc
| ) |  |

inline

Creates a packet to store the given PDF data.

The data array must contain a full PDF document as a block of binary data.

The alloc argument shows if/how this packet claims ownership of the data. In particular, unless alloc is DEEP_COPY, this packet will claim ownership of the given data block and will deallocate it when the packet is destroyed. If alloc is DEEP_COPY then the given block of data will not be modified in any way.

It is possible to pass a null pointer as the data array, in which case the new packet will have no PDF document stored.

Python:
  Not present.

Parameters

  data | the block of binary data that forms the PDF document, or `null` if no document is to be stored.
  size | the number of bytes in this block of binary data; if actual data is passed (i.e., data is not `null`) then this must be strictly positive.
  alloc | describes if/how this packet should claim ownership of the given block of data; see the notes above for details.

regina::NPDF::~NPDF | ( |  | ) |

inline

Destroys this PDF packet and deallocates data if required.

## Member Function Documentation

const char * regina::NPDF::data | ( |  | ) | const

inline

Returns a pointer to the block of raw data that forms this PDF document.

The number of bytes in this block can be found by calling size().

If no PDF document is currently stored, this routine will return a null pointer.

Python:
  Not present.

Returns
  the raw PDF data.

bool regina::NPDF::dependsOnParent | ( |  | ) | const

inline virtual

Determines if this packet depends upon its parent.

This is true if the parent cannot be altered without invalidating or otherwise upsetting this packet.

Returns
  `true` if and only if this packet depends on its parent.

Implements regina::NPacket.

NPacket * regina::NPDF::internalClonePacket | ( | NPacket * | parent | ) | const

inline protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Implements regina::NPacket.

void regina::NPDF::reset | ( |  | ) |

Empties this PDF packet so that no document is stored.

The old data will be deallocated if required.

void regina::NPDF::reset | ( | char * | data,
|  | size_t | size,
|  | OwnershipPolicy | alloc
| ) |  |

Refills this PDF packet with the given PDF data.

The old data will be deallocated if required.

This routine behaves like the class constructor; see the constructor documentation for details.

Python:
  Not present.

Parameters

  data | the block of binary data that forms the new PDF document, or `null` if no document is to be stored.
  size | the number of bytes in this new block of binary data; if actual data is passed (i.e., data is not `null`) then this must be strictly positive.
  alloc | describes if/how this packet should claim ownership of the given block of data; see the notes above for details.

size_t regina::NPDF::size | ( |  | ) | const

inline

Returns the size of this PDF document in bytes.

If no PDF document is currently stored, this routine will return zero.

Returns
  the number of bytes.

void regina::NPDF::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

virtual void regina::NPDF::writeXMLPacketData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the data for this packet only.

You may assume that the packet opening tag (including the packet type and label) has already been written, and that all child packets followed by the corresponding packet closing tag will be written immediately after this routine is called. This routine need only write the internal data stored in this specific packet.

Parameters

  out | the output stream to which the XML should be written.

Implements regina::NPacket.

The documentation for this class was generated from the following file:

- packet/npdf.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).